import numpy as np

def affiene_hull(points):
    points = np.array(points)
    
    if points.shape[0] < 2:
        raise ValueError("Ten minste 2 punten nodig om affiene deelruimte te vinden.")
        
    vectors = points - points[0]
    rank = np.linalg.matrix_rank(vectors)
    dimension = rank

    return points, dimension

# Voorbeeld: vierkant in 3D
if __name__ == "__main__":
    points = np.array([
        [1, 2, 4],
        [2, 3, 5],
        [3, 2, 2],
        [4, 5, 7]
    ])

    hull_points, hull_dimension = affiene_hull(points)

    print("Dimensie van de affiene deelruimte:", hull_dimension)